#!/bin/bash
# (c) Andreas Lindenau DL4JAL
# Version 0.2
# 02.07.2021

#==============================================================================
# Variable Strings zum Kompilieren und Programmieren
QUELLTEXT=mc
LKR=18f46k22_g.lkr
PIC=PIC18F46K22
#==============================================================================
# Paths in extra Datei
source ../pathconfig

# Datei "error.pic" ist vorhanden
if [ -e error.pic ]
then
# Datei loeschen
  rm error.pic
fi
# Datei "error.pic" wird neu angelegt beim Kompilieren
#$GPASM -c -w0 $QUELLTEXT.pic | tee error.pic
$GPASM -c -w1 $QUELLTEXT.pic | tee error.pic
$GPLINK -o $QUELLTEXT.hex -c -a inhx32 -s $LINKERSCRIPT/$LKR -m $QUELLTEXT.o | tee -a error.pic
# Datei exitstiert, ist aber nicht leer
if [ -s error.pic ]
then
  echo "Kompilieren: Es sind Fehler aufgetreten!"
  exit 1
else
  echo "Kompilieren: Fehlerfrei!"
#  echo $1
#  echo $2
#  echo $#
# Anzahl der Argumente gleich 0 
  if [ $# -eq 0 ]
  then
    exit 0
  fi
  if [ $# -eq 1 ]
  then
    OPTION1=$1
    OPTION2=''
    OPTION3=''
  fi
  if [ $# -eq 2 ]
  then
    OPTION1=$1
    OPTION2=$2
    OPTION3=''
  fi
  if [ $# -eq 3 ]
  then
    OPTION1=$1
    OPTION2=$2
    OPTION3=$3
  fi
# Inhalt des Argumentes1 gleich "-p" beteutet "PIC Programmieren"
  if [ $OPTION1 = "-p" ]
  then
    echo "Programmieren mit NSPROG."
    $NSPROG p $OPTION2 $OPTION3 -d$PIC -i $QUELLTEXT.hex
    $NSPROG v $OPTION2 $OPTION3 -d$PIC -i $QUELLTEXT.hex
  fi
  exit 0
fi
